%define is_f19 %(test "0%{?fedora}" -eq "019" && echo 1 || echo 0)

%if 0%{?fedora} >= 15 || 0%{?rhel} >= 7
%global with_systemd 1
%endif

Summary:        A plugin to make oVirt Node installs compatible with oVirt Engine and vdsm
Name:           ovirt-node-plugin-vdsm
Version:        0.2.0
Release:        26%{?BUILD_NUMBER}%{?extra_release}%{?dist}
Source0:        %{name}-0.2.0_master.tar.gz
License:        GPLv2+
Group:          Applications/System

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL:            http://www.ovirt.org/
Requires:       python
Requires:       vdsm-reg >= 4.10.3
Requires:       ovirt-host-deploy-offline >= 1.3.0
Requires:       ovirt-node-plugin-hosted-engine
%if ! 0%{?centos}
Requires:       vdsm-hook-vhostmd
%endif
Requires:       vdsm-hook-ethtool-options
Requires(post): augeas

BuildArch:      noarch
BuildRequires:  python2-devel
BuildRequires:  autoconf
BuildRequires:  automake

Patch0:   0000-downstream-only-replace-rhel-macro.patch
Patch1:   0001-downstream-only-remove-requires-vdsm-gluster.patch
Patch2:   0002-downstreamonly-replaces-ovirt-engine-to-rhevm.patch
Patch3:   0003-Include-hosted-engine-plugin-into-iso-form-3.5-on.patch
Patch4:   0004-downstreamonly-removes-requires-ovirt-node.patch
Patch5:   0005-downstream-add-features-empty-to-version-file.patch
Patch6:   0006-hooks-Add-02-sanlock-check-into-on-boot.patch
Patch7:   0007-Add-03-vdsm-sebool-config-handler.patch
Patch8:   0008-hooks-Move-sanlock-upgrade-hook-to-post-upgrade.patch
Patch9:   0009-page-Use-package-name-everywhere.patch
Patch10:  0010-hook-Start-vdsmd-explicitly-again.patch
Patch11:  0011-hooks-Update-sebool-hook-to-stay-in-sync-w-vdsm.patch
Patch12:  0012-spec-enable-vdsm-reg-to-autostart.patch
Patch13:  0013-engine_page-Replace-oVirt-Engine-str-with-constant.patch
Patch14:  0014-downstream-only-remove-ks-hosted-engine.patch
Patch15:  0015-downstream-only-remove-duplicate-engine-data.patch 
Patch16:  0016-spec-Add-vdsm-hook-ethtool-options-as-req.patch
Patch17:  0017-engine_page-Replace-deployUtil._logExec.patch
Patch18:  0018-engine_page-Catch-exception-KeyError.patch
Patch19:  0019-spec-set-requires-HE.patch
Patch20:  0020-page-Be-more-specififc-about-the-Engine-password.patch

%define app_root %{_datadir}/%{name}
%define recipe_root %{_datadir}/ovirt-node-recipe

%description
Provides UI and associated scripts for integrating oVirt Node and oVirt Engine

%package recipe
Summary:        Kickstarts for building oVirt Node isos including %{name}
Group:          Applications/System
Requires:       ovirt-node-recipe >= 2.6.0

%description recipe
Provides kickstart files for generating an oVirt Node ISO image containing
%{name}.

%prep
%setup -q -n %{name}-0.2.0_master
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1

# Required autoconf to update build system
autoreconf

%build
%configure

%install
%{__rm} -rf %{buildroot}
make install DESTDIR=%{buildroot}

%post
if [ "$1" -eq 1 ] ; then
%if 0%{?with_systemd}
    /bin/systemctl enable vdsm-reg.service >/dev/null 2>&1 || :
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
%else
    /sbin/chkconfig --add vdsm-reg
%endif
fi

# reserve vdsm port 54321
augtool << \EOF_sysctl
set /files/etc/sysctl.conf/net.ipv4.ip_local_reserved_ports 54321
save
EOF_sysctl

#SELinux Booleans
/usr/sbin/setsebool -P virt_use_nfs=1 \
                       virt_use_sanlock=1 \
                       sanlock_use_nfs=1

# ensure Network Manager is disabled
%if %{is_f19}
/usr/bin/systemctl mask NetworkManager.service
%endif

%preun

%files recipe
%{recipe_root}

%files
%{python_sitelib}/ovirt/node/setup/vdsm
%{_libexecdir}/ovirt-node/hooks/pre-upgrade/01-vdsm
%{_libexecdir}/ovirt-node/hooks/on-boot/01-vdsm-configure
%{_libexecdir}/ovirt-node/hooks/on-boot/02-vdsm-sebool-config
%{_libexecdir}/ovirt-node/hooks/on-boot/90-start-vdsm
%{_libexecdir}/ovirt-node/hooks/post-upgrade/01-sanlock-check
%{_sysconfdir}/ovirt-plugins.d
%{_sysconfdir}/default/version.ovirt-node-plugin-vdsm

%changelog
* Fri Jul 31 2015 Fabian Deutsch <fdeutsch@redhat.com> 0.2.0-26
- Be more detailed when setting the RHEV-M password

* Mon Jun 08 2015 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-25
- Add requires ovirt-node-plugin-hosted-engine

* Thu May 21 2015 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-24
- Revert the last three patches applied, in versions 0.2.0-23 and 0.2.0-22

* Tue May 19 2015 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-23
- engine_page: Add validation for engine_data

* Fri May 08 2015 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-22
- engine_page: use augeas instead of Management
- engine_page: augeas set copy_if_rename_fails

* Mon Apr 13 2015 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-21
- Remove ovirt-node-plugin-hosted-engine from recipe

* Tue Mar 10 2015 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-20
- engine_page: Replace deployUtil._logExec
- engine_page: Catch exception KeyError

* Tue Mar 03 2015 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-19
- Enable in recipe hosted-engine plugin

* Mon Jan 19 2015 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-18
- spec: Add vdsm-hook-ethtool-options as req (BZ#1183626)

* Sun Dec 21 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-17
- Remove duplicate engine_data var

* Thu Dec 18 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-16
- Remove ovirt-node-plugin-hosted-engine from recipe

* Tue Dec 16 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-15
- engine_page: Replace oVirt Engine str with constant

* Tue Nov 25 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-13
- spec: enable vdsm-reg to autostart

* Fri Nov 14 2014 Fabian Deutsch <fdeutsch@redhat.com> 0.2.0-12
- Adjust sebool handler

* Fri Nov 07 2014 Fabian Deutsch <fdeutsch@redhat.com> 0.2.0-11
- Add sebool handling
- Move sanlock check to post-upgrade
- Ensure consistent use of product name
- Start vdsmd explicitly

* Tue Oct 07 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-10
- Add FEATURES=kdump

* Wed Sep 24 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-9
- Add sanlock user check

* Tue Sep 23 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-8
- Add features to version file

* Mon Sep 22 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-7
- Add autoreconf

* Tue Sep 09 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-6
- Remove ovirt-node requires

* Sun Sep 07 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-5
- update spec for ovirt-node requires

* Sun Sep 07 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-4
- update requires of ovirt-node to 3.0.1 as it get patched to 3.0.4

* Sat Aug 02 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-3
- added changelog

* Sat Aug 02 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-2
- 0003-Include-hosted-engine-plugin-into-iso-form-3.5-on.patch

* Thu Jul 24 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 0.2.0-1
- Replaces oVirt Engine to RHEV-M

* Thu Jun 12 2014 Douglas Schilling Landgraf <dougsland@redhat.com> 2.0.0
- Increase the version/release

* Fri May 17 2013 Mike Burns <mburns@redhat.com> 0.0.2
- Rename to ovirt-node-plugin-vdsm
- rebase onto ovirt-node 3.0.0 codebase
- add note about changing sshd when setting passwd
- fix password changing
- fix some requirements
- add minimization

* Fri Feb 15 2013 Mike Burns <mburns@redhat.com> 0.0.1
- initial commit
- engine_page from current ovirt-node
